function Simu = GARCH_DGP(sample_size,p,q)
if(p>4 || q>4)
    warning('too high values of p or q'); %#ok<*WNTAG>
    p = 2;
    q = 2;
end
theta_ARCH = [0.15 0.1 0.025 0.05];
theta_sigma = [0.8 0.2 0.1 0.05];
theta = [0.1 theta_ARCH(1:p) theta_sigma(1:q)]';

sigma = zeros(sample_size,1);
y = zeros(sample_size,1);
val_max = max(p,q);
sigma(1:val_max) = theta(1)/(1-sum(theta(2:end)));
y(1:val_max) = sqrt(sigma(1:val_max)).*randn(val_max,1);

y_sq = y(val_max:-1:val_max-p+1).*y(val_max:-1:val_max-p+1);
sigma_prev = sigma(val_max:-1:val_max-q+1);

for t=val_max+1:sample_size
   sigma(t) = theta(1) +  sum(theta(2:p+1).*y_sq) + sum(theta(p+2:end).*sigma_prev);
   
   y(t) = sqrt(sigma(t))*randn();
   y_sq = y(t:-1:t-p+1).*y(t:-1:t-p+1);
   sigma_prev = sigma(t:-1:t-q+1);
end
Simu.y = y;
Simu.sigma = sigma;
Simu.theta = theta;
