function [MLE_theta MLE_like] = MLE_GARCH(y,nb_repeat)
if(nargin<2)
    nb_repeat=5;
end

dim = size(y);
if(dim(1,2)>dim(1,1))
    y = y';
end
y_sq = y.*y;
T = max(dim);

    
option = optimset('MaxIter',1e7,'MaxFunEvals',1e7,'Display','iter');
for i=1:nb_repeat
    [theta] = starting_values(y_sq);
    [MLE_estimates max_like] = fminunc(@(theta) launch_GARCH_likelihood_for_MLE(y_sq,theta),theta,option);

   if(i==1)
       MLE_theta = MLE_estimates;
       MLE_like = max_like;
   elseif(max_like<MLE_like)
       MLE_theta = MLE_estimates;
       MLE_like = max_like;
   end
       
end
MLE_like = MLE_like*-1;